function [A,F]=f1(b1, c1, d1, xa, xt, n, eidos, ua, ut)
%[A,F]=f1(b1, c1, d1, xa, xt, n, eidos, ua, ut)
%I sinartisi afti linei provlimata sinoriakon sinthikon
%----------------------------------------------------------------
%Dexetai san orismata tou sintelestes b, c, d pou
%edo emfanizontai me ta onomata b1, c1, d1 kai prokeintai
%gia sinartiseis tou x. Gia to d prepei na isxuei:
%d(x)=-u"(x)+b(x)*u'(x)+c(x)*u(x) me b(x), c(x)
%ta b1, c1  kai u(x) tin sinartissei pou psaxnoume. Episis san
%orismata dinoume kai to diastima orismou [xa,xt] kai to arithmo
%ton isapexonton komvon n.
%An tora gnorizoume ta:
%1)|--Dirichlet-Dirichlet--| 
%  u(xa),u(xt) thetoume ua=u(xa),ut=u(xt) kai eidos=1
%2)|--Neumann-Dirichlet--|
%  u'(xa),u(xt) thetoume ua=u'(xa),ut=u(xt) kai eidos=2
%3)|--Dirichlet-Neumann--|
%  u(xa),u'(xt) thetoume ua=u(xa),ut=u'(xt) kai eidos=3
%4)|--Neumann-Neumann--|
%  u'(xa),u'(xt) thetoume ua=u'(xa),ut=u'(xt) kai eidos=4
%5)|--Periodiki sinartisi sta akra--|
%  eidos=5, ta ua kai ut edo perisseuoun
%----------------------------------------------------------------
%San apotelesma i sinartisi dinei to mitroo sinteleston A kai to
%deksio melos F oste A*x=F
%----------------------------------------------------------------

%euresi ton sinteleston os sinartiseis tou x
b=inline(b1,'x');
c=inline(c1,'x');
d=inline(d1,'x');

%euresi tou diastimatos h pou apexei o enas komvos apo ton allo
h=(xt-xa)/(n+1);

%parakato opou emfanizontai ta aa, bb, cc ennoountai ta , ,  
%apo tin theoria

%elegxos gia to se poia periptosi vriskomaste
%Dirichlet-Dirichlet
if eidos==1
    aa=zeros(n,1);
    bb=zeros(n-1,1);
    cc=zeros(n-1,1);
    F=zeros(n,1);
    %euresi ton , ,  pou xreiazontai gia tin dimiourgia tou
    %tridiagoniou mitroou A=trid[,,]
    for i=1:1:n-1
        aa(i,1)=2/(h^2) + c(xa+i*h);
        bb(i,1)=-1/(h^2) + b(xa+i*h)/(2*h);
        cc(i,1)=-1/(h^2) -b(xa+(i+1)*h)/(2*h);
    end
    aa(n,1)=2/(h^2) + c(xa+n*h);
    %euresi tou F
    F(1,1)=d(xa+h)+ua/(h^2)+b(xa+h)*ua/(2*h);
    for i=2:1:n-1
        F(i,1)=d(xa+i*h);
    end
    F(n,1)=d(xa+n*h)+ut/(h^2)-b(xa+n*h)*ut/(2*h);
end
%Neumann-Dirichlet
if eidos==2
    aa=zeros(n+1,1);
    bb=zeros(n,1);
    cc=zeros(n,1);
    F=zeros(n+1,1);
    %euresi ton , ,  pou xreiazontai gia tin dimiourgia tou
    %tridiagoniou mitroou A=trid[,,]
    aa(1,1)=2/(h^2)+c(xa);
    bb(1,1)=-2/(h^2);
    cc(1,1)=-1/(h^2) -b(xa+h)/(2*h);
    for i=2:1:n
        aa(i,1)=2/(h^2)+c(xa+(i-1)*h);
        bb(i,1)=-1/(h^2) + b(xa+(i-1)*h)/(2*h);
        cc(i,1)=-1/(h^2) -b(xa+i*h)/(2*h);
    end    
    aa(n+1,1)=2/(h^2)+c(xa+n*h);
    %euresi tou F
    F(1,1)=d(xa)-b(xa)*ua-2*ua/h;
    for i=2:1:n
        F(i,1)=d(xa+(i-1)*h);
    end
    F(n+1,1)=d(xa+n*h)+ut/(h^2)-b(xa+n*h)*ut/(2*h);
end
%Dirichlet-Neumann
if eidos==3
    aa=zeros(n+1,1);
    bb=zeros(n,1);
    cc=zeros(n,1);
    F=zeros(n+1,1);
    %euresi ton , ,  pou xreiazontai gia tin dimiourgia tou
    %tridiagoniou mitroou A=trid[,,]
    for i=1:1:n-1
        aa(i,1)=2/(h^2)+c(xa+i*h);
        bb(i,1)=-1/(h^2) + b(xa+i*h)/(2*h);
        cc(i,1)=-1/(h^2) -b(xa+(i+1)*h)/(2*h);
    end
    aa(n,1)=2/(h^2)+c(xa+n*h);
    bb(n,1)=-1/(h^2) + b(xa+n*h)/(2*h);
    cc(n,1)=-2/(h^2);
    aa(n+1,1)=2/(h^2)+c(xa+(n+1)*h);
    %euresi tou F
    F(1,1)=d(xa+h)+ua/(h^2)+b(xa+h)*ua/(2*h);
    for i=2:1:n
        F(i,1)=d(xa+i*h);
    end
    F(n+1,1)=d(xt)-b(xt)*ut+2*ut/h;
end
%Neumann-Neumann
if eidos==4
    aa=zeros(n+2,1);
    bb=zeros(n+1,1);
    cc=zeros(n+1,1);
    F=zeros(n+2,1);
    %euresi ton , ,  pou xreiazontai gia tin dimiourgia tou
    %tridiagoniou mitroou A=trid[,,]
    aa(1,1)=2/(h^2)+c(xa);
    bb(1,1)=-2/(h^2);
    cc(1,1)=-1/(h^2) -b(xa+h)/(2*h);
    for i=2:1:n
        aa(i,1)=2/(h^2)+c(xa+(i-1)*h);
        bb(i,1)=-1/(h^2) + b(xa+(i-1)*h)/(2*h);
        cc(i,1)=-1/(h^2) -b(xa+i*h)/(2*h);
    end
    aa(n+1,1)=2/(h^2)+c(xa+n*h);
    bb(n+1,1)=-1/(h^2) + b(xa+n*h)/(2*h);
    cc(n+1,1)=-2/(h^2);
    aa(n+2,1)=2/(h^2)+c(xt);
    %euresi tou F
    F(1,1)=d(xa)-b(xa)*ua-2*ua/h;
    for i=2:1:n+1
        F(i,1)=d(xa+(i-1)*h);
    end
    F(n+2,1)=d(xt)-b(xt)*ut+2*ut/h;
end
%Periodiki sinartisi sta akra
if eidos==5
    aa=zeros(n+1,1);
    bb=zeros(n,1);
    cc=zeros(n,1);
    F=zeros(n+1,1);
    %euresi ton , ,  pou xreiazontai gia tin dimiourgia tou
    %tridiagoniou mitroou A=trid[,,]
    for i=1:1:n
        aa(i,1)=2/(h^2) + c(xa+i*h);
        bb(i,1)=-1/(h^2) + b(xa+i*h)/(2*h);
        cc(i,1)=-1/(h^2) -b(xa+(i+1)*h)/(2*h);
    end
    aa(n+1,1)=2/(h^2) + c(xt);
    %euresi tou F
    for i=1:1:n+1
        F(i,1)=d(xa+i*h);
    end
end
%dimiourgia tou tridiagoniou mitroou A=trid[,,]
A=GALLERY('tridiag',cc,aa,bb);

%Periodiki sinartisi sta akra
if eidos==5
    %se afti ti peritosei prepei na prosthesoume alla dio stoixeia
    %ston mexri stigmis tridiagonio A pou dilonoun pera ton allon
    %oti ta u(xa) kai u(xt) einai isa
    A(1,n+1)=-1/(h^2)-b(xa+h)/(2*h);
    A(n+1,1)=-1/(h^2)+b(xt)/(2*h);
end