function [A,flags]=f2(b1, c1, d1, xa, xt, n, eidos, ua, ut)
%[flags]=f2(b1, c1, d1, xa, xt, n, eidos, ua, ut)
%I sinartisi afti vriskei to eidos tou mitroou pou prokiptei apo
%ena provlima sinoriakon sinthikon
%----------------------------------------------------------------
%Dexetai san orismata tou sintelestes b, c, d pou
%edo emfanizontai me ta onomata b1, c1, d1 kai prokeintai
%gia sinartiseis tou x. Gia to d prepei na isxuei:
%d(x)=-u"(x)+b(x)*u'(x)+c(x)*u(x) me b(x), c(x)
%ta b1, c1  kai u(x) tin sinartissei pou psaxnoume. Episis san
%orismata dinoume kai to diastima orismou [xa,xt] kai to arithmo
%ton isapexonton komvon n.
%An tora gnorizoume ta:
%1)|--Dirichlet-Dirichlet--| 
%  u(xa),u(xt) thetoume ua=u(xa),ut=u(xt) kai eidos=1
%2)|--Neumann-Dirichlet--|
%  u'(xa),u(xt) thetoume ua=u'(xa),ut=u(xt) kai eidos=2
%3)|--Dirichlet-Neumann--|
%  u(xa),u'(xt) thetoume ua=u(xa),ut=u'(xt) kai eidos=3
%4)|--Neumann-Neumann--|
%  u'(xa),u'(xt) thetoume ua=u'(xa),ut=u'(xt) kai eidos=4
%5)|--Periodiki sinartisi sta akra--|
%  eidos=5, ta ua kai ut edo perisseuoun
%----------------------------------------------------------------
%San apotelesma i sinartisi dinei ena pinaka flags pou ta stoixeia tou mas
%deixnoun an to prokipton mitroo einai
%1)simmetriko--->flags(1,1)=1
%2)thetika orismeno i imiorismeno--->flags(2,1)=1
%3)toeplitz--->flags(3,1)=1
%4)araio--->flags(4,1)=1
%5)kikloteres--->flags(5,1)=1
%6)mi antistrepsimo--->flags(6,1)=1
%----------------------------------------------------------------

%euresi ton sinteleston os sinartiseis tou x
b=inline(b1,'x');
c=inline(c1,'x');
d=inline(d1,'x');

%euresi tou diastimatos h pou apexei o enas komvos apo ton allo
h=(xt-xa)/(n+1);

%parakato opou emfanizontai ta aa, bb, cc ennoountai ta , ,  
%apo tin theoria

%elegxos gia to se poia periptosi vriskomaste
%Dirichlet-Dirichlet
if eidos==1
    aa=zeros(n,1);
    bb=zeros(n-1,1);
    cc=zeros(n-1,1);
    k=n;
    %euresi ton , ,  pou xreiazontai gia tin dimiourgia tou
    %tridiagoniou mitroou A=trid[,,]
    for i=1:1:n-1
        aa(i,1)=2/(h^2) + c(xa+i*h);
        bb(i,1)=-1/(h^2) + b(xa+i*h)/(2*h);
        cc(i,1)=-1/(h^2) -b(xa+(i+1)*h)/(2*h);
    end
    aa(n,1)=2/(h^2) + c(xa+n*h);
end
%Neumann-Dirichlet
if eidos==2
    aa=zeros(n+1,1);
    bb=zeros(n,1);
    cc=zeros(n,1);
    k=n+1;
    %euresi ton , ,  pou xreiazontai gia tin dimiourgia tou
    %tridiagoniou mitroou A=trid[,,]
    aa(1,1)=2/(h^2)+c(xa);
    bb(1,1)=-2/(h^2);
    cc(1,1)=-1/(h^2) -b(xa+h)/(2*h);
    for i=2:1:n
        aa(i,1)=2/(h^2)+c(xa+(i-1)*h);
        bb(i,1)=-1/(h^2) + b(xa+(i-1)*h)/(2*h);
        cc(i,1)=-1/(h^2) -b(xa+i*h)/(2*h);
    end    
    aa(n+1,1)=2/(h^2)+c(xa+n*h);
end
%Dirichlet-Neumann
if eidos==3
    aa=zeros(n+1,1);
    bb=zeros(n,1);
    cc=zeros(n,1);
    k=n+1;
    %euresi ton , ,  pou xreiazontai gia tin dimiourgia tou
    %tridiagoniou mitroou A=trid[,,]
    for i=1:1:n-1
        aa(i,1)=2/(h^2)+c(xa+i*h);
        bb(i,1)=-1/(h^2) + b(xa+i*h)/(2*h);
        cc(i,1)=-1/(h^2) -b(xa+(i+1)*h)/(2*h);
    end
    aa(n,1)=2/(h^2)+c(xa+n*h);
    bb(n,1)=-1/(h^2) + b(xa+n*h)/(2*h);
    cc(n,1)=-2/(h^2);
    aa(n+1,1)=2/(h^2)+c(xa+(n+1)*h);
end
%Neumann-Neumann
if eidos==4
    aa=zeros(n+2,1);
    bb=zeros(n+1,1);
    cc=zeros(n+1,1);
    k=n+2;
    %euresi ton , ,  pou xreiazontai gia tin dimiourgia tou
    %tridiagoniou mitroou A=trid[,,]
    aa(1,1)=2/(h^2)+c(xa);
    bb(1,1)=-2/(h^2);
    cc(1,1)=-1/(h^2) -b(xa+h)/(2*h);
    for i=2:1:n
        aa(i,1)=2/(h^2)+c(xa+(i-1)*h);
        bb(i,1)=-1/(h^2) + b(xa+(i-1)*h)/(2*h);
        cc(i,1)=-1/(h^2) -b(xa+i*h)/(2*h);
    end
    aa(n+1,1)=2/(h^2)+c(xa+n*h);
    bb(n+1,1)=-1/(h^2) + b(xa+n*h)/(2*h);
    cc(n+1,1)=-2/(h^2);
    aa(n+2,1)=2/(h^2)+c(xt);
end
%Periodiki sinartisi sta akra
if eidos==5
    aa=zeros(n+1,1);
    bb=zeros(n,1);
    cc=zeros(n,1);
    k=n+1;
    %euresi ton , ,  pou xreiazontai gia tin dimiourgia tou
    %tridiagoniou mitroou A=trid[,,]
    for i=1:1:n
        aa(i,1)=2/(h^2) + c(xa+i*h);
        bb(i,1)=-1/(h^2) + b(xa+i*h)/(2*h);
        cc(i,1)=-1/(h^2) -b(xa+(i+1)*h)/(2*h);
    end
    aa(n+1,1)=2/(h^2) + c(xt);
end
%dimiourgia tou tridiagoniou mitroou A=trid[,,]
A=GALLERY('tridiag',cc,aa,bb);

%Periodiki sinartisi sta akra
if eidos==5
    %se afti ti peritosei prepei na prosthesoume alla dio stoixeia
    %ston mexri stigmis tridiagonio A pou dilonoun pera ton allon
    %oti ta u(xa) kai u(xt) einai isa
    A(1,n+1)=-1/(h^2)-b(xa+h)/(2*h);
    A(n+1,1)=-1/(h^2)+b(xt)/(2*h);
end

flags=zeros(6,1);

%an to b(x)=0 tote to A einai simmetriko
if b1=='0'
    flags(1,1)=1;
end

x=rand(k,1);
%an to x'*A*x>0 tote to A einai thetika orismeno i imiorismeno
if ((x')*A*x)>0
    flags(2,1)=1;
end

notequal=1;
for i=1:1:k-2
    %ta antidiametrika stoixeia tis diagoniou einai isa?
    if A(i+1,i)~=A(i+2,i+1)
        notequal=0;
    end
    if A(i,i+1)~=A(i+1,i+2)
        notequal=0;
    end    
    if A(i,i)~=A(i+1,i+1)
        notequal=0;
    end
end
if A(k-1,k-1)~=A(k,k)
    notequal=0;
end

%einai toeplitz?
if notequal==1
    flags(3,1)=1;
    %einai kikloteres?
    if eidos==5
        flags(5,1)=1;
    end
end

%an k>15 einai araio
if k>15
    flags(4,1)=1;
end

%euresi ton idiotimon tou A
[V]=eigs(A);
zeroidiotimi=0;
for i=1:1:length(V)
    %einai isi me 0 i idiotimi se afti ti thesi tou dianismatos?
    if V(i,1)==0
        zeroidiotimi=1;
    end
end

%an iparxei mideniki idiotimi tote to A einai mi antistrapsimo
if zeroidiotimi==1
    flag(6,1)=1;
end
